//------------------------------------------------------------------
//
//------------------------------------------------------------------

#property indicator_separate_window
#property indicator_buffers 3
#property indicator_minimum 0
#property indicator_maximum 1
#property indicator_color1 LimeGreen
#property indicator_color2 Red
#property indicator_color3 Red
#property indicator_width1 2
#property indicator_width2 2
#property indicator_width3 2

extern string ChoseTimeFrame  = "current time frame";
extern int    BarsTocalculate = 500;
extern double Smoothing       = 5;

double UPBuffer[];
double DOWNBuffer1[];
double DOWNBuffer2[];
double trend[];

int iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};
int size;
int from;
//------------------------------------------------------------------
//
//------------------------------------------------------------------
int init()
{
   size = ArraySize(iTfTable);
   from = 0;
   int startTimeFrame = stringToTimeFrame(ChoseTimeFrame);
   for (int i=size-1; i>=0; i--)
         if (startTimeFrame==iTfTable[i]) { from = i; break; }
         if (ChoseTimeFrame!="") size = from+1;
         string add = "";       
            for (int k=from; k<size; k++) add = add+timeFrameToString(iTfTable[k])+" ";

         
         //
         //
         //
         //
         //
                  
   IndicatorBuffers(4);
   SetIndexBuffer(0,UPBuffer);
   SetIndexBuffer(1,DOWNBuffer1);
   SetIndexBuffer(2,DOWNBuffer2);
   SetIndexBuffer(3,trend);
   IndicatorShortName("Trend analysis "+add);
   return(0);
}
int deinit() { return(0); }
int start()
{
   int bars = BarsTocalculate; if (bars<=0) bars = Bars-1;
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
           int limit=MathMin(MathMin(MathMax(Bars-counted_bars,2*iTfTable[size-1]/Period()),bars),Bars-1);

   //
   //
   //
   //
   //

   if (trend[limit]==-1) CleanPoint(limit,DOWNBuffer1,DOWNBuffer2);
   for(int i=limit; i>=0; i--)
   {
      double divisor = 0;
      double UP = 0;
      for (int k=from; k<size; k++)
      {
         divisor += 13;
         int y = iBarShift(NULL,iTfTable[k],Time[i]);
            if (iMA(NULL,iTfTable[k],20,0,MODE_SMA,PRICE_CLOSE,y)>iMA(NULL,iTfTable[k],20,0,MODE_SMA,PRICE_CLOSE,y+1))                   UP += 1;
            if (iMA(NULL,iTfTable[k],50,0,MODE_SMA,PRICE_CLOSE,y)>iMA(NULL,iTfTable[k],50,0,MODE_SMA,PRICE_CLOSE,y+1))                   UP += 1;
            if (iMA(NULL,iTfTable[k],100,0,MODE_SMA,PRICE_CLOSE,y)>iMA(NULL,iTfTable[k],100,0,MODE_SMA,PRICE_CLOSE,y+1))                 UP += 1;
            if (iADX(NULL,iTfTable[k],14,PRICE_CLOSE,MODE_MAIN,y)>iADX(NULL,iTfTable[k],14,PRICE_CLOSE,MODE_MAIN,y+1))                   UP += 1;
            if (iBearsPower(NULL,iTfTable[k], 13,PRICE_CLOSE,y)>iBearsPower(NULL,iTfTable[k], 13,PRICE_CLOSE,y+1))                       UP += 1;
            if (iBullsPower(NULL,iTfTable[k], 13,PRICE_CLOSE,y)>iBullsPower(NULL,iTfTable[k], 13,PRICE_CLOSE,y+1))                       UP += 1;
            if (iCCI(NULL,iTfTable[k],14,PRICE_CLOSE,y)>iCCI(NULL,iTfTable[k],14,PRICE_CLOSE,y+1))                                       UP += 1;
            if (iDeMarker(NULL,iTfTable[k], 13, y)>iDeMarker(NULL,iTfTable[k], 13, y+1))                                                 UP += 1;
            if (iForce(NULL,iTfTable[k],13,MODE_SMA,PRICE_CLOSE,y)>iForce(NULL,iTfTable[k],13,MODE_SMA,PRICE_CLOSE,y+1))                 UP += 1;
            if (iMACD(NULL,iTfTable[k],12,26,9,PRICE_CLOSE,MODE_MAIN,y)>iMACD(NULL,iTfTable[k],12,26,9,PRICE_CLOSE,MODE_MAIN,y+1))       UP += 1;
            if (iMomentum(NULL,iTfTable[k],14,PRICE_CLOSE,y)>iMomentum(NULL,iTfTable[k],14,PRICE_CLOSE,y+1))                             UP += 1;
            if (iRSI(NULL,iTfTable[k],14,PRICE_CLOSE,y)>iRSI(NULL,iTfTable[k],14,PRICE_CLOSE,y+1))                                       UP += 1;
            if (iStochastic(NULL,iTfTable[k],5,3,3,MODE_SMA,0,MODE_MAIN,y)>iStochastic(NULL,iTfTable[k],5,3,3,MODE_SMA,0,MODE_MAIN,y+1)) UP += 1;
      }            
      UP /= divisor;
            DOWNBuffer1[i] = EMPTY_VALUE;
            DOWNBuffer2[i] = EMPTY_VALUE;
            UPBuffer[i]    = iSsm(UP,Smoothing,i,0);
               if (UPBuffer[i]>0.5)
                     trend[i] =  1;
               else  trend[i] = -1;
            if (trend[i]==-1) PlotPoint(i,DOWNBuffer1,DOWNBuffer2,UPBuffer);
   }      
   return(0);
}

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

void CleanPoint(int i,double& first[],double& second[])
{
   if ((second[i]  != EMPTY_VALUE) && (second[i+1] != EMPTY_VALUE))
        second[i+1] = EMPTY_VALUE;
   else
      if ((first[i] != EMPTY_VALUE) && (first[i+1] != EMPTY_VALUE) && (first[i+2] == EMPTY_VALUE))
          first[i+1] = EMPTY_VALUE;
}

//
//
//
//
//

void PlotPoint(int i,double& first[],double& second[],double& tfrom[])
{
   if (i>=Bars-2) return;
   if (first[i+1] == EMPTY_VALUE)
         {
            if (first[i+2] == EMPTY_VALUE) 
                  { first[i]  = tfrom[i]; first[i+1]  = tfrom[i+1]; second[i] = EMPTY_VALUE; }
            else  { second[i] = tfrom[i]; second[i+1] = tfrom[i+1]; first[i]  = EMPTY_VALUE; }
         }
   else  { first[i] = tfrom[i]; second[i] = EMPTY_VALUE; }
}

//
//
//
//
//

#define Pi 3.14159265358979323846264338327950288
double workSsm[][2];
#define _tprice  0
#define _ssm    1

double workSsmCoeffs[][4];
#define _period 0
#define _c1     1
#define _c2     2
#define _c3     3

//
//
//
//
//

double iSsm(double price, double period, int i, int instanceNo)
{
   if (period<=1) return(price);
   if (ArrayRange(workSsm,0) !=Bars)                 ArrayResize(workSsm,Bars);
   if (ArrayRange(workSsmCoeffs,0) < (instanceNo+1)) ArrayResize(workSsmCoeffs,instanceNo+1);
   if (workSsmCoeffs[instanceNo][_period] != period)
   {
      workSsmCoeffs[instanceNo][_period] = period;
      double a1 = MathExp(-1.414*Pi/period);
      double b1 = 2.0*a1*MathCos(1.414*Pi/period);
         workSsmCoeffs[instanceNo][_c2] = b1;
         workSsmCoeffs[instanceNo][_c3] = -a1*a1;
         workSsmCoeffs[instanceNo][_c1] = 1.0 - workSsmCoeffs[instanceNo][_c2] - workSsmCoeffs[instanceNo][_c3];
   }
   i = Bars-i-1;

   //
   //
   //
   //
   //

      int s = instanceNo*2;   
          workSsm[i][s+_tprice] = price;
          workSsm[i][s+_ssm]    = workSsmCoeffs[instanceNo][_c1]*(workSsm[i][s+_tprice]+workSsm[i-1][s+_tprice])/2.0 + 
                                  workSsmCoeffs[instanceNo][_c2]*workSsm[i-1][s+_ssm]                                + 
                                  workSsmCoeffs[instanceNo][_c3]*workSsm[i-2][s+_ssm]; 
   return(workSsm[i][s+_ssm]);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};

//
//
//
//
//

int stringToTimeFrame(string tfs) {
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf) {
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}
string stringUpperCase(string str) { string s = str; StringToUpper(s); return(s); }